package org.rcisoft.business.jzmessage.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.kingdee.entity.KingDeeJzMessageDTO;
import org.rcisoft.business.userwarning.entity.UserWarning;
import org.rcisoft.core.base.CyBaseMapper;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.springframework.stereotype.Repository;


import java.util.List;
import java.util.Map;

/**
 * Created with lpy on 2019-7-24 17:40:17.
 */
@Repository
public interface JzMessageRepository extends CyBaseMapper<JzMessage> {


    /*@Select("<script>select * from jz_message where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<JzMessage> queryJzMessages(JzMessage jzMessage);*/

    /**
     * 分页查询 jzMessage
     *
     */
 /*   @Select("<script>select distinct jz.*,if(uw.business_id is null,0,1) as isWaring,sde1.name as curDeptName," +
            " su1.name as curUserName,su3.name as projectOwner,su3.dept_id as projectOwnerDeptId," +
            " sdi.name jzLocationName," +
            " sdi2.name as ywxName," +
            " uw.type as uwType," +
            " uw.jz_status as jzStatus, " +
            " sdi3.name as yysDjName," +
            " sdi4.name as yysYdName," +
            " sdi5.name as yysTtName," +
            " sdi6.name as upperYdName," +
            " sdi7.name as upperTtName" +
            " from jz_message jz " +
            " left join user_warning uw on jz.business_id = uw.jz_id and uw.warning_status = '0' and uw.user_id = jz.jz_cur_user "+
            " left join s_dept sde1 on jz.jz_cur_dept = sde1.BUSINESS_ID" +
            " left join s_user su1 on jz.jz_cur_user = su1.BUSINESS_ID" +
            " left join s_user su3 on jz.jz_project_owner = su3.BUSINESS_ID" +
            " left join s_dictionary sdi on jz.jz_qy = sdi.`value` and sdi.type = #{jzLocation} " +
            " left join s_dictionary sdi2 on jz.business_line = sdi2.`value` and sdi2.type = 'JZ_YWX'" +
            " left join s_dictionary sdi3 on jz.jz_yys = sdi3.`value` and sdi3.type = 'JZ_DJ_YYS'  " +
            " left join s_dictionary sdi4 on jz.jz_yys = sdi4.`value` and sdi4.type = 'JZ_YD_YYS'  " +
            " left join s_dictionary sdi5 on jz.jz_yys = sdi5.`value` and sdi5.type = 'JZ_TT_YYS'  " +
            " left join s_dictionary sdi6 on jz.jz_up_custom = sdi6.`value` and sdi6.type = 'JZ_YD_UPPER' " +
            " left join s_dictionary sdi7 on jz.jz_up_custom = sdi7.`value` and sdi7.type = 'JZ_TT_UPPER' " +
            " where 1=1 " +
            "<if test = \"jzYys !=null and jzYys != '' and sDicYysType.toString() eq 'JZ_DJ_YYS'.toString() \"> and sdi3.value = #{jzYys} </if>" +
            "<if test = \"jzYys !=null and jzYys != '' and sDicYysType.toString() eq 'JZ_YD_YYS'.toString() \"> and sdi4.value = #{jzYys} </if>" +
            "<if test = \"jzYys !=null and jzYys != '' and  sDicYysType.toString() eq 'JZ_TT_YYS'.toString() \"> and sdi5.value = #{jzYys} </if>" +
            "<if test = \"jzUpCustom !=null and jzUpCustom != '' and  sDicUpperType.toString() eq 'JZ_YD_UPPER'.toString() \"> and sdi6.value = #{jzUpCustom} </if>" +
            "<if test = \"jzUpCustom !=null and jzUpCustom != '' and  sDicUpperType.toString() eq 'JZ_TT_UPPER'.toString() \"> and sdi7.value = #{jzUpCustom} </if>" +

            "<if test = \"jzQy !=null and jzQy != ''\"> and jz.jz_qy = #{jzQy} </if>" +
            "<if test =\"isNotSpecialRole !=null and isNotSpecialDept !=null \">" +
            "<if test =\"isNotSpecialRole and isNotSpecialDept\">" +
            "and jz_cur_dept in" +
            "<foreach collection =\"deptIdList\" item=\"item\" open=\"(\" separator=\",\" close =\")\">  #{item} </foreach>"+
            "</if>" +
            "</if>" +
            "<if test =\"isSalesMan != null and isSalesMan\">" +
            " " +
            "</if>" +
            "<if test=\"delFlag !=null and delFlag != '' \">and jz.del_flag = #{delFlag} </if> "+
            "<if test=\"flag !=null and flag != '' \">and jz.flag = #{flag} </if> "+
            "<if test=\"jzName !=null and jzName != '' \">and jz_name like concat('%',#{jzName},'%') </if> "+
            "<if test=\"jzCode !=null and jzCode != '' \">and jz_code like concat('%',#{jzCode},'%') </if> "+
            "<if test=\"projectCode !=null and projectCode != '' \">and project_code like concat('%',#{projectCode},'%') </if> "+
            "<if test=\"businessLine !=null and businessLine != '' \">and business_line  = #{businessLine}  </if> "+
            "<if test=\"jzCurDept !=null and jzCurDept != '' \">and jz_cur_dept  = #{jzCurDept}  </if> "+
            "<if test=\" (jzState !=null and jzState != '') and (listJzState ==null or listJzState.size()==0 ) \">and jz.jz_state = #{jzState} </if> "+
            "<if test=\"listJzState !=null and listJzState.size()>0 \"> and jz.jz_state in " +
            "<foreach collection=\"listJzState\" item=\"state\" open =\"(\" separator=\",\" close=\")\"> " +
            " #{state} " +
            "</foreach> " +
            "</if> "+
            "<if test=\"jzType !=null and jzType != '' \">and jz_type = #{jzType} </if> "+
   *//*         "<if test=\"jzCurDept !=null and SELECT sd.name as title, 'true' as expand, sd.PARENT_ID, sd.business_id FROM s_dept sd WHERE 1 = 1 and sd.DEL_FLAG = ? and sd.FLAG = ? and sd.PARENT_ID = ? ORDER BY sort jzCurDept != '' \">and jz_cur_dept = #{jzCurDept} </if> "+*//*
            "<if test=\"curUserNames !=null and curUserNames != '' \"> " +
            "<foreach collection=\"curUserNames\" item=\"name\" open =\"and(\" separator=\"or\" close=\")\"> " +
            "su1.name like concat('%',#{name},'%') " +
            "</foreach> " +
            "</if> "+
            "<if test=\"businessIds != null and businessIds[0].trim() != '' \"> and jz.business_id in " +
            "<foreach collection=\"businessIds\" item=\"businessId\" open =\"(\" separator=\",\" close=\")\"> " +
            "#{businessId} " +
            "</foreach> " +
            "</if> " +
            "<if test=\"exportSort != null and exportSort != '' \"> order by jz.create_date desc  </if> "+
            "</script>")
    @ResultMap("BaseResultMap")
    List<JzMessage> queryJzMessages(JzMessage jzMessage);*/


    /**
     * 分页查询 jzMessage
     *
     */
    @Select("<script>select distinct  jz.*,sde1.name as curDeptName," +
            " su1.name as curUserName,su3.name as projectOwner,su3.dept_id as projectOwnerDeptId" +
            " from jz_message jz " +
            " left join s_dept sde1 on jz.jz_cur_dept = sde1.BUSINESS_ID" +
            " left join s_user su1 on jz.jz_cur_user = su1.BUSINESS_ID" +
            " left join s_user su3 on jz.jz_project_owner = su3.BUSINESS_ID" +
//            代缴
            "<if test =\" jzType !=null and jzType !='' and jzType.toString() eq '0'.toString \">"+
            " left join s_dictionary sdi3 on jz.jz_yys = sdi3.`value` and sdi3.type = 'JZ_DJ_YYS'  " +
            "</if>"+

            /*移动*/
            "<if test =\" jzType !=null and jzType !='' and jzType.toString() eq '1'.toString \">"+
            " left join s_dictionary sdi4 on jz.jz_yys = sdi4.`value` and sdi4.type = 'JZ_YD_YYS'  " +
            " left join s_dictionary sdi6 on jz.jz_up_custom = sdi6.`value` and sdi6.type = 'JZ_YD_UPPER' " +
            "</if>"+

            /*铁塔*/
            "<if test =\" jzType !=null and jzType !='' and jzType.toString() eq '2'.toString \">"+
            " left join s_dictionary sdi5 on jz.jz_yys = sdi5.`value` and sdi5.type = 'JZ_TT_YYS'  " +
            " left join s_dictionary sdi7 on jz.jz_up_custom = sdi7.`value` and sdi7.type = 'JZ_TT_UPPER' " +
            "</if>"+

            " where 1=1 " +
            "<if test = \"jzYys !=null and jzYys != '' and sDicYysType.toString() eq 'JZ_DJ_YYS'.toString() \"> and sdi3.value = #{jzYys} </if>" +
            "<if test = \"jzYys !=null and jzYys != '' and sDicYysType.toString() eq 'JZ_YD_YYS'.toString() \"> and sdi4.value = #{jzYys} </if>" +
            "<if test = \"jzYys !=null and jzYys != '' and  sDicYysType.toString() eq 'JZ_TT_YYS'.toString() \"> and sdi5.value = #{jzYys} </if>" +
            "<if test = \"jzUpCustom !=null and jzUpCustom != '' and  sDicUpperType.toString() eq 'JZ_YD_UPPER'.toString() \"> and sdi6.value = #{jzUpCustom} </if>" +
            "<if test = \"jzUpCustom !=null and jzUpCustom != '' and  sDicUpperType.toString() eq 'JZ_TT_UPPER'.toString() \"> and sdi7.value = #{jzUpCustom} </if>" +

            "<if test = \"jzQy !=null and jzQy != ''\"> and jz.jz_qy = #{jzQy} </if>" +
            "<if test =\"isNotSpecialRole !=null and isNotSpecialDept !=null \">" +
            "<if test =\"isNotSpecialRole and isNotSpecialDept\">" +
            "and jz_cur_dept in" +
            "<foreach collection =\"deptIdList\" item=\"item\" open=\"(\" separator=\",\" close =\")\">  #{item} </foreach>"+
            "</if>" +
            "</if>" +
            "<if test =\"isSalesMan != null and isSalesMan\">" +
            " " +
            "</if>" +
            "<if test=\"delFlag !=null and delFlag != '' \">and jz.del_flag = #{delFlag} </if> "+
            "<if test=\"flag !=null and flag != '' \">and jz.flag = #{flag} </if> "+
            "<if test=\"jzName !=null and jzName != '' \">and jz_name like concat('%',#{jzName},'%') </if> "+
            "<if test=\"jzCode !=null and jzCode != '' \">and jz_code like concat('%',#{jzCode},'%') </if> "+
            "<if test=\"projectCode !=null and projectCode != '' \">and project_code like concat('%',#{projectCode},'%') </if> "+
            "<if test=\"businessLine !=null and businessLine != '' \">and business_line  = #{businessLine}  </if> "+
            "<if test=\"jzCurDept !=null and jzCurDept != '' \">and jz_cur_dept  = #{jzCurDept}  </if> "+
            "<if test=\" (jzState !=null and jzState != '') and (listJzState ==null or listJzState.size()==0 ) \">and jz.jz_state = #{jzState} </if> "+
            "<if test=\"listJzState !=null and listJzState.size()>0 \"> and jz.jz_state in " +
            "<foreach collection=\"listJzState\" item=\"state\" open =\"(\" separator=\",\" close=\")\"> " +
            " #{state} " +
            "</foreach> " +
            "</if> "+
            "<if test=\"jzType !=null and jzType != '' \">and jz_type = #{jzType} </if> "+
   /*         "<if test=\"jzCurDept !=null and SELECT sd.name as title, 'true' as expand, sd.PARENT_ID, sd.business_id FROM s_dept sd WHERE 1 = 1 and sd.DEL_FLAG = ? and sd.FLAG = ? and sd.PARENT_ID = ? ORDER BY sort jzCurDept != '' \">and jz_cur_dept = #{jzCurDept} </if> "+*/
            "<if test=\"curUserNames !=null and curUserNames != '' \"> " +
            "<foreach collection=\"curUserNames\" item=\"name\" open =\"and(\" separator=\"or\" close=\")\"> " +
            "su1.name like concat('%',#{name},'%') " +
            "</foreach> " +
            "</if> "+
            "<if test=\"businessIds != null and businessIds[0].trim() != '' \"> and jz.business_id in " +
            "<foreach collection=\"businessIds\" item=\"businessId\" open =\"(\" separator=\",\" close=\")\"> " +
            "#{businessId} " +
            "</foreach> " +
            "</if> " +
            "<if test=\"exportSort != null and exportSort != '' \"> order by jz.create_date desc  </if> "+
            "</script>")
    @ResultMap("BaseResultMap")
    List<JzMessage> queryJzMessages(JzMessage jzMessage);



    /**
     * 更新流程状态,基站状态,进度日期,预警
     */
    @Update("<script> update jz_message " +
            "<trim prefix=\"set\" suffixOverrides=\",\" >" +
            "<if test=\"originalProState != null and originalProState !=''\">  original_pro_state = #{originalProState}, </if>" +
            "<if test=\"originalState != null and originalState !=''\">  original_state = #{originalState}, </if>" +
            "<if test=\"isImport != null and isImport !=''\">  is_import = #{isImport}, </if>" +
            "<if test=\"projectCodeImport != null and projectCodeImport !=''\">  project_code_import = #{projectCodeImport}, </if>" +
            "<if test=\"jzState != null and jzState !=''\">  jz_state = #{jzState}, </if>" +
            "<if test=\"jzProState != null and jzProState !=''\">  jz_pro_state = #{jzProState}, </if>" +
            "<if test=\"jzJdDate != null \">  jz_jd_date = #{jzJdDate}, </if>" +
            "<if test=\"jzJdWaring != null and jzJdWaring !=''\">  jz_jd_waring = #{jzJdWaring}, </if>" +
            "</trim> " +
            " where 1=1 " +
            "<if test=\"delFlag !=null and delFlag != '' \"> and del_flag = #{delFlag} </if> "+
            "<if test=\"flag !=null and flag != '' \"> and flag = #{flag} </if> "+
            " and business_id = #{businessId}  "+
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    int updateJzMessage(JzMessage jzMessage);


    /**
     *左连接业务员警告表，查询未被警告的基站 是否对业务员预警（用于后面的时间比较，将在指定时间内未完成的业务员加入基站业务员警告表）
     */
    @Select("<script> SELECT " +
            "jm.business_id, " +
            "jm.jz_cur_user, " +
            "uw.type, " +
            "uw.message, " +
            "uw.warning_status, " +
            "jm.jz_jd_date, " +
            "jm.jz_pro_state, " +
            "jz_project_owner " +
            "FROM " +
            "jz_message AS jm " +
            "LEFT JOIN ( " +
            "SELECT " +
            "* " +
            "FROM " +
            "user_warning " +
            "WHERE " +
            "type = #{type} " +
            "AND warning_status = '0' " +
            "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> " +
            "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> " +
            ") AS uw ON jm.business_id = uw.jz_id " +
            "WHERE " +
            "jm.jz_jd_waring = '0' " +
            "<if test =\"jzType !=null and jzType != '' \">AND jm.jz_type = #{jzType} </if>  " +
            "AND jm.jz_state = #{jzState}" +
            "</script>")
    @ResultMap(value = "BaseResultMap")
    List<JzMessage> selectUndoUserNotInTable(JzMessage jzMessage);
    /**
     *左连接业务员警告表，查询已被警告的基站，是否对经理预警（用于后面的时间比较，将在指定时间内未完成的业务员加入基站业务员警告表）
     */
    @Select("<script> SELECT " +
            "jm.business_id, " +
            "jm.jz_cur_user, " +
            "uw.type, " +
            "uw.message, " +
            "uw.warning_status, " +
            "jm.jz_jd_date, " +
            "jm.jz_pro_state, " +
            "jz_project_owner " +
            "FROM " +
            "jz_message AS jm " +
            "LEFT JOIN ( " +
            "SELECT " +
            "* " +
            "FROM " +
            "user_warning " +
            "WHERE " +
            "type = #{type} " +
            "AND warning_status = '0' " +
            "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> " +
            "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> " +
            ") AS uw ON jm.business_id = uw.jz_id " +
            "WHERE " +
            "1 = 1 " +
            "<if test =\"jzType !=null and jzType != '' \">AND jm.jz_type = #{jzType} </if>  " +
            "and jm.jz_state = #{jzState}" +
            "</script>")
    @ResultMap(value = "BaseResultMap")
    List<JzMessage> selectUndoManagerNotInTable(JzMessage jzMessage);
    /**
     * 批量更新基站预警信息为 已预警（1）
     * @param jzMessageList
     * @return
     */
    @Update("<script> update jz_message set jz_jd_waring = 1 where 1=1 and business_id in " +
            "<foreach collection =\"jzMessageList\" item=\"item\" open=\"(\" separator=\",\" close =\")\">  #{item.businessId} </foreach>" +
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    int updateJzJdWaring(@Param("jzMessageList") List<JzMessage> jzMessageList);
    /**
     * 批量插入信息
     */
    @Insert("<script> insert into jz_message (business_id, " +
            "create_by, " +
            "create_date, " +
            "update_by, " +
            "update_date, " +
            "del_flag, " +
            "flag, " +
            "remarks, " +
            "jz_code, " +
            "jz_name, " +
            "jz_ewm, " +
            "project_code, " +
            "business_line, " +
            "jz_yys, " +
            "jz_qy, " +
            "project_address, " +
            "jz_pro_state, " +
            "jz_state, " +
            "jz_type, " +
            "jz_create_date, " +
            "jz_init_user, " +
            "jz_init_dept, " +
            "jz_cur_user, " +
            "jz_cur_dept, " +
            "jz_up_custom, " +
            "jz_require, " +
            "jz_construct, " +
            "jz_mobile_name, " +
            "jz_mobile_phone, " +
            "jz_longitude, " +
            "jz_latitude, " +
            "jz_version, " +
            "jz_xgid, " +
            "jz_jd_date, " +
            "jz_jd_waring, " +
            "jz_prospectlist_name, " +
            "jz_prospectlist_path, " +
            "jz_designdrawing_name, " +
            "jz_designdrawing_path, " +
            "jz_elementlist_name, " +
            "jz_elementlist_path, " +
            "jz_outboundlist_name, " +
            "jz_outboundlist_path, " +
            "jz_operatoracceptlist_name, " +
            "jz_operatoracceptlist_path, " +
            "jz_routedrawing_name, " +
            "jz_routedrawing_path, " +
            "jz_completedacceptlist_name, " +
            "jz_completedacceptlist_path, " +
            "jz_uppermachineroomplace, " +
            "jz_ne_id, " +
            "jz_opendrawing_name, " +
            "jz_opendrawing_path, " +
            "jz_propertycode, " +
            "jz_isconnectwithowner, " +
            "jz_propertyname, " +
            "jz_ownercontactinfo, " +
            "jz_budgetofelectic_name, " +
            "jz_budgetofelectic_path, " +
            "jz_matterlist_name, " +
            "jz_matterlist_path, " +
            "jz_openrepory_name, " +
            "jz_openrepory_path, " +
            "jz_constructprocept_name, " +
            "jz_constructprocept_path, " +
            "jz_completedreport_name,"+
            "jz_completedreport_path,"+
            "jz_completedphoto_name,"+
            "jz_completedphoto_path,"+
            "jz_rentdrawing_name, " +
            "jz_rentdrawing_path, " +
            "jz_project_id, " +
            "jz_project_owner, " +
            "jz_ewm_drawing, " +
            "jz_mobile_relation, " +
            "jz_map_link) values " +
            "<foreach collection =\"jzMessageList\" item=\"item\"  separator=\",\" >" +
            "(" +
            "#{item.businessId}, " +
            "#{item.createBy}, " +
            "#{item.createDate}, " +
            "#{item.updateBy}, " +
            "#{item.updateDate}, " +
            "#{item.delFlag}, " +
            "#{item.flag}, " +
            "#{item.remarks}, " +
            "#{item.jzCode}, " +
            "#{item.jzName}, " +
            "#{item.jzEwm}, " +
            "#{item.projectCode}, " +
            "#{item.businessLine}, " +
            "#{item.jzYys}, " +
            "#{item.jzQy}, " +
            "#{item.projectAddress}, " +
            "#{item.jzProState}, " +
            "#{item.jzState}, " +
            "#{item.jzType}, " +
            "#{item.jzCreateDate}, " +
            "#{item.jzInitUser}, " +
            "#{item.jzInitDept}, " +
            "#{item.jzCurUser}, " +
            "#{item.jzCurDept}, " +
            "#{item.jzUpCustom}, " +
            "#{item.jzRequire}, " +
            "#{item.jzConstruct}, " +
            "#{item.jzMobileName}, " +
            "#{item.jzMobilePhone}, " +
            "#{item.jzLongitude}, " +
            "#{item.jzLatitude}, " +
            "#{item.jzVersion}, " +
            "#{item.jzXgid}, " +
            "#{item.jzJdDate}, " +
            "#{item.jzJdWaring}, " +
            "#{item.jzProspectlistName}, " +
            "#{item.jzProspectlistPath}, " +
            "#{item.jzDesigndrawingName}, " +
            "#{item.jzDesigndrawingPath}, " +
            "#{item.jzElementlistName}, " +
            "#{item.jzElementlistPath}, " +
            "#{item.jzOutboundlistName}, " +
            "#{item.jzOutboundlistPath}, " +
            "#{item.jzOperatoracceptlistName}, " +
            "#{item.jzOperatoracceptlistPath}, " +
            "#{item.jzRoutedrawingName}, " +
            "#{item.jzRoutedrawingPath}, " +
            "#{item.jzCompletedacceptlistName}, " +
            "#{item.jzCompletedacceptlistPath}, " +
            "#{item.jzUppermachineroomplace}, " +
            "#{item.jzNeId}, " +
            "#{item.jzOpendrawingName}, " +
            "#{item.jzOpendrawingPath}, " +
            "#{item.jzPropertycode}, " +
            "#{item.jzIsconnectwithowner}, " +
            "#{item.jzPropertyname}, " +
            "#{item.jzOwnercontactinfo}, " +
            "#{item.jzBudgetofelecticName}, " +
            "#{item.jzBudgetofelecticPath}, " +
            "#{item.jzMatterlistName}, " +
            "#{item.jzMatterlistPath}, " +
            "#{item.jzOpenreporyName}, " +
            "#{item.jzOpenreporyPath}, " +
            "#{item.jzConstructproceptName}, " +
            "#{item.jzConstructproceptPath}, " +
            "#{item.jzCompletedreportName}, " +
            "#{item.jzCompletedreportPath}, " +
            "#{item.jzCompletedphotoName}, " +
            "#{item.jzCompletedphotoPath}, " +
            "#{item.jzRentdrawingName}, " +
            "#{item.jzRentdrawingPath}, " +
            "#{item.jzProjectId}, " +
            "#{item.jzProjectOwner}, " +
            "#{item.jzEwmDrawing}, " +
            "#{item.jzMobileRelation}," +
            "#{item.jzMapLink})</foreach>" +
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    int batchInsert(@Param("jzMessageList") List<JzMessage> jzMessageList);
    /**
     * 查询项目Id
     *
     */
    @Select("<script> select jz_project_id from jz_message where jz_project_id like concat('%',#{jzProjectId},'%')" +
            "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> " +
            "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> " +
            " order by jz_project_id desc" +
            "</script>")
    @ResultMap(value = "BaseResultMap")
    List<JzMessage> queryJzProjectId(JzMessage jzMessage);

    /**
     * 通过项目编号去查询
     */
    @Select("<script> select * from jz_message" +
            " where 1 = 1 " +
            "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> " +
            "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> " +
            " and project_code = #{projectCode}"+
            "</script>")
    @ResultMap(value = "BaseResultMap")
    JzMessage queryProjectCodeExcel(JzMessage jzMessage);




    /**
     * 通过id去查询
     */
    @Select("<script> select * from jz_message where " +
            "business_id = #{businessId}"+
            "</script>")
    @ResultMap(value = "BaseResultMap")
    JzMessage jzmessageByBusinessId(@Param("businessId") String jzMessageId);
    /**
     * 根据当前登录人id 查询当前基站信息
     */
    @Select("<script>select jz.business_id from jz_message jz " +
            "left join s_user su on jz.jz_cur_user = su.business_id " +
            "where jz.jz_cur_user = #{userBid}" +
            "</script>")
    @ResultMap(value = "BaseResultMap")
    List<JzMessage> queryJzMessageByUserId(@Param("userBid") String userBid);

   /*
   * 根据基站id查询是code是否存在重复
   * */
   @Select("<script>SELECT jz_message.project_code FROM jz_message where 1=1  " +
           "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> " +
           "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> " +
           " AND jz_message.business_id !=#{businessId} </script>")
    List<String> queryprojectCodeByBusinessId(JzMessage jzMessage);

    /**
     * 查询所有项目编号
     * @param
     * @return
     */
    @Select("<script>SELECT jz_message.project_code FROM jz_message where 1=1  " +
            "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = 0 </if> " +
            "<if test=\"flag !=null and flag != '' \">and flag = 1 </if> " +
            "</script>")
    List<String> queryprojectCode();
    /**
     * 更新需求号为空
     */
    @Update("<script>update jz_message set jz_require = null where business_id = #{businessId}</script>")
    @ResultMap(value = "BaseResultMap")
    int updateJzRequire(JzMessage jzMessage);

    /**
     * 根据isImprot查询数据
     */
    @Select("<script> select * from jz_message where 1=1 " +
            "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> " +
            "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> " +
            " AND is_import = #{isImport} AND project_code_import = #{projectCodeImport}  AND project_code IS NOT NULL order by update_date desc</script>")
    @ResultMap(value = "BaseResultMap")
    List<JzMessage> queryJzMessageByIsImport(JzMessage jzMessage);

    /*
    * 根据ProjectCodeImport查询
    * */
    @Select("<script> select * from jz_message where 1=1 " +
            "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> " +
            "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> " +
            " AND project_code_import = #{projectCodeImport} AND project_code IS NOT NULL order by update_date desc</script>")
    @ResultMap(value = "BaseResultMap")
    List<JzMessage> queryJzMessageByProjectCodeImport(JzMessage jzMessage);


    /**
     * 金蝶更新
     *
     */
    @Update("<script> update jz_message " +
            "set " +
            "update_date = #{updateTime}," +
            "jz_code = #{jzCode}," +
            "jz_name = #{jzName}," +
            "project_code = #{projectCode}," +
            "business_line = #{jzYWX}," +
            "jz_qy = #{jzQy}," +
            "jz_state = #{jzState}," +
            "jz_cur_user = #{jzcurUser}," +
            "jz_cur_dept = #{jzCurDept}," +
            "project_address = #{projectAddress}," +
            "jz_project_owner = #{jzProjectOwner}" +
            "WHERE king_number = #{kingNumber}</script>")
    int updateJzMEssageByKingDee(KingDeeJzMessageDTO kingDeeJzMessageDTO);

    @Select("<script>select * from jz_message where  king_number = #{KingNumber}</script>")
    @ResultMap(value = "BaseResultMap")
    List<JzMessage> selectJztypeByKingNumber(@Param("KingNumber") String KingNumber);

    /**
     * 查询可以自动走流程的基站
     */
    @Select("<script>select * from jz_message where 1 = 1" +
            "<if test=\"delflag != null and delflag != ''\">AND del_flag = #{delFlag}</if>" +
            "<if test=\"flag != null and flag != ''\">AND flag = #{flag}</if>" +
            "AND is_can_run_process = #{isCanRunProcess}" +
            "AND is_can_run_process IS NOT NULL" +
            "AND jz_type IN ('1','2')" +
            "ORDER BY update_date</script>")
    @ResultMap(value = "BaseResultMap")
    List<JzMessage> queryIsCanRunProcessJzMessage(JzMessage jzMessage);
}

