package org.rcisoft.business.processDesign.dao;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.processDesign.entity.WorkflowTaskDataHi;
import org.rcisoft.core.base.CyBaseMapper;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
 * Created with cy on 2019-7-26 16:12:11.
 */
@Repository
public interface WorkflowTaskDataHiRepository extends CyBaseMapper<WorkflowTaskDataHi> {

    /**
     * 分页查询 workflowTaskDataHi
     */
    @Select("<script>select * from workflow_task_data_hi where 1=1 "
            + "</script>")
    @ResultMap(value = "BaseResultMap")
    List<WorkflowTaskDataHi> queryWorkflowTaskDataHis(WorkflowTaskDataHi workflowTaskDataHi);

    @Select("<script>select * from workflow_task_data_hi where field_id in " +
            "<foreach item=\"item\" collection=\"list\" open=\"(\" separator=\",\" close=\")\">" +
            "#{item} </foreach>" +
            "</script>")
    @ResultMap(value = "BaseResultMap")
    List<WorkflowTaskDataHi> dataHiBytaskId(@Param("list") List<String> list);


    @Insert("<script> insert into workflow_task_data_hi (id, " +
            "field_id, " +
            "field_value, " +
            "task_data_mes_id ) values " +
            "<foreach collection =\"datahi\" item=\"item\"  separator=\",\" >" +
            "(#{item.id}, " +
            "#{item.fieldId}, " +
            "#{item.fieldValue}, " +
            "#{item.taskDataMesId})</foreach>" +
            "</script>")
    void insertList(@Param("datahi") List<WorkflowTaskDataHi> datahi);
}

