package org.rcisoft.business.kingdee.timeTask;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 17:07  2019/9/11
 * @Modified By:
 */


import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.jzmessage.dao.JzMessageRepository;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.business.kingdee.commom.K3CloundConfig;
import org.rcisoft.business.kingdee.commom.KDFormIdEnum;
import org.rcisoft.business.kingdee.commom.KingDee;
import org.rcisoft.business.kingdee.control.KingdeeControl;
import org.rcisoft.business.kingdee.service.KingdeeMyselfService;
import org.rcisoft.business.kingdee.service.KingdeeService;
import org.rcisoft.business.kingdee.service.impl.KingDeeMyselfProCodeServiceImpl;
import org.rcisoft.business.kingdee.service.impl.KingdeeMyselfServiceImpl;
import org.rcisoft.business.kingdee.until.BaseUtil;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.service.CyBaseService;
import org.rcisoft.core.util.CyUserUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @date 2019/1/4 15:07
 */
@Component
@Slf4j
public class TimerTask extends CyBaseService {
    private final static String UserName = "Administrator";
    private final static String DBid = "5d8acc5a26042d";
    private final static String password = "kJyGjIQ5DW0tpd@B";
    private final static int icon = 2052;
    @Autowired
    private KingdeeService kingdeeService;
    @Autowired
    private K3CloundConfig k3CloundConfig;
    @Autowired
    private KingdeeControl kingdeeControl;
    @Autowired
    private JzMessageRepository jzMessageRepository;
    @Autowired
    private KingdeeMyselfServiceImpl kingdeeMyselfService;
    @Autowired
    private KingDeeMyselfProCodeServiceImpl kingDeeMyselfProCodeService;

    private static final String POST_K3CloudUR = "";

      @Scheduled(cron = "0 0/5 * * * ?")
   // @Scheduled(cron = "0 0/15 * * * ?")
      @Async("executor1")
    public void login() throws IOException {

        //登录金蝶系统
        log.debug("定时任务启动——————————————————————————");
        String loginParam = BaseUtil.buildLogin(k3CloundConfig.getDBid(), k3CloundConfig.getUsername(), k3CloundConfig.getPassword(), k3CloundConfig.getIcon());
        CyResult login = kingdeeService.login(k3CloundConfig.getUrl() + k3CloundConfig.getLogin(), loginParam);
        if (login.getCode() == 400) {
           // this.dbError("登录金蝶系统失败" +login.getMessage());
            log.info("【登录金蝶系统失败】：{}", login.getMessage());
            return;
        }
        log.debug("登录启动成功——————————————————————————");

        Map<String, Object> map = (Map<String, Object>) login.getData();
        String cookie = map.get("cookie").toString();
        //项目编号保存
        kingDeeMyselfProCodeService.kingDeeProCode(cookie);
        log.debug("项目编号保存启动成功——————————————————————————");
        //项目保存
        kingdeeMyselfService.Kingdee(cookie);
        log.debug("项目保存启动成功——————————————————————————");

    }

}
